(import
  (chicken file)
  (chicken pathname)
  (chicken platform)
  (chicken port)
  (chicken process)
  (chicken process-context))

(unless (get-environment-variable "SALMONELLA_RUNNING")
  (let* ((dir (create-temporary-directory))
         (egg-cache-dir (make-pathname (list dir ".cache") #f))
         (lay-cache-dir (make-pathname (list dir ".lay") #f))
         (install-dir   (make-pathname (list dir ".install") #f)))
    (print dir)
    (set-environment-variable! "CHICKEN_INSTALL_PREFIX"     install-dir)
    (set-environment-variable! "CHICKEN_INSTALL_REPOSITORY" install-dir)
    (set-environment-variable! "CHICKEN_REPOSITORY_PATH"    
                               (with-output-to-string
                                 (lambda ()
                                   (for-each (lambda (elem) (display elem) (display ":"))
                                             (repository-path))
                                   (display install-dir))))
    (set-environment-variable! "CHICKEN_EGG_CACHE"          egg-cache-dir)
    (set-environment-variable! "CHICKEN_LAY_CACHE"          lay-cache-dir)
    (system* "../lay -j 8 http-client")
    (system* (string-append (executable-pathname) " -s test.scm"))
    (delete-directory dir #t)))
